<template>
  <div>
    <page-background />
    <div class="home">
      <header class="header">
        <div class="header__logo" />

        <div class="dropdown">
          <div class="dropdown__selected"> 
            🌐 {{ $t('global.language') }} 
          </div>
          <ul class="dropdown__content">
            <li class="dropdown__content-item" @click="changeLocale('pt-BR')"> Português </li>
            <li class="dropdown__content-item" @click="changeLocale('en-US')"> English </li>
          </ul>
        </div>

        <h3 class="my-4 font-medium" v-html="$t('global.description')" />
      </header>

      <div class="event__wrapper">
        <event 
          v-for="(event, index) in eventList"
          :key="`event_${index}`"
          :id="event.id"
          :title="event.title"
          :participants="event.participants"
          :date="event.date"
          :local="event.local"
          :shortDescription="event.shortDescription"
          :linearGradient="event.linearGradient"
          :index="index"
        />

        <div class="all" @click="redirect">
          <h3> {{ $t('global.sponsorAll') }} </h3>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters, mapMutations } from 'vuex';

import Event from '@/components/Event.vue';
import PageBackground from '@/components/PageBackground.vue';

export default Vue.extend({
  components: {
    Event,
    PageBackground,
  },

  computed: {
    ...mapGetters({
      eventList: 'getEventList',
    }),
  },

  methods: {
    changeLocale(locale: string): void {
      const { $i18n }: any = this;
      $i18n.locale = locale;
    },

    redirect(): void {
      const { $store, $router }: any = this;
      ($router as any).history.push(`/pricing/all`);
    },
  },
});
</script>

<style lang="postcss">
.home {
  @apply absolute px-8 text-white h-screen w-screen z-10 overflow-y-scroll;
}

.header__logo {
  @apply bg-no-repeat bg-center bg-contain;
  background-image: url("../assets/sticker-luh-min.png");

  height: 40vh;
}

.event__wrapper {
  @apply flex flex-col flex-wrap justify-around items-center;
}

.all {
  @apply flex flex-col justify-center items-center;
  @apply my-4 rounded-lg p-4 text-white text-4xl text-center cursor-pointer w-full;

  height: 50vh;
  background: linear-gradient(180deg, #ffed4a 0%, #684f1d 100%);
}

.dropdown {
  @apply relative inline-block cursor-pointer;

  left: calc(100vw - 14rem);
}

.dropdown__selected {
  @apply bg-orange text-white p-4 rounded;

  min-width: 10rem;
}

.dropdown__content {
  @apply hidden absolute bg-white list-reset rounded;
}

.dropdown__content-item {
  @apply p-2 text-black;

  min-width: 10rem;
}

.dropdown__content-item:first-child {
  @apply rounded-t;
}

.dropdown__content-item:last-child {
  @apply rounded-b;
}

.dropdown__content-item:hover {
  @apply bg-grey;
}

.dropdown__selected:hover {
  @apply bg-orange-dark;
}

.dropdown:hover .dropdown__content {
  display: block;
}

@screen lg {
  .event__wrapper {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    grid-template-areas:
      "interhack shehacks deephack"
      "all all all";
    grid-row-gap: 2rem;
    grid-column-gap: 2rem;

    justify-items: stretch;
    align-items: stretch;
  }

  .all {
    @apply h-full;

    grid-area: all;
  }

}
</style>
